# coffeelint: disable=max_line_length
Eventemitter = require('events').EventEmitter
emitter = new Eventemitter()
child_process = require 'child_process'
_ = require 'lodash'
debug = require("debug")("omg-channels:bchannels")
helpers = require './channels-helpers'
iconvlite = require("iconv-lite")
fs = require 'fs'
async = require 'async'
ko = require 'knockout'

running = true

bchannelsList = []#.extend({rateLimit: 10, notify: "always"})
getBchannelList = ->
  child_process.exec "getchannels -m -b 2>&1 | grep -v 'Channels found'", (error, stdout) -> # omitted stderr
    stdout = stdout.toString()
    channels = stdout.split("\n")
    channels = _.filter channels, (line) ->
      (line isnt "") and (line.indexOf("B-Channels and") is -1)
    # _.each channels, (bchannelName) ->
    #   bchannelsLocal[bchannelName] = {fullName: bchannelName}
    bchannelsList = channels

    # touch all files in /tmp to trigger update of currently running calls
    child_process.exec "touch /tmp/*"
    emitter.emit "changed"
getBchannelList()

bchannelConfigs = {}
watchDir = "/tmp/"

readChangedFiles = async.queue (filename, cb) ->
  debug "check if #{filename} exists"
  # check if file still exists before reading it
  fs.exists "#{watchDir}#{filename}", (exists) ->
    unless exists
      debug "#{filename} does not exist"
      return

    debug "reading #{filename}"
    fs.readFile "#{watchDir}#{filename}", (err, content) ->
      if err
        debug "could not read #{filename}"
        return
      decodedContent = iconvlite.decode(content, "utf-8")
      channelProperties = decodedContent.split("--")
      completeBchannelInfo = {}
      debug "setting complete channel info"
      _.each channelProperties, (keyValObject) ->
        tempArray = keyValObject.split("=")
        newKey = tempArray[0]
        newVal = tempArray[1]
        try
          newKey = JSON.parse(newKey)
        try
          newVal = JSON.parse(newVal)
        completeBchannelInfo[newKey] = newVal

      bchannelName = completeBchannelInfo.bchannel

      if completeBchannelInfo.error is "none" or completeBchannelInfo.error is "active"
        completeBchannelInfo.active = true
      else
        completeBchannelInfo.active = false

      bchannelConfigs[bchannelName] = completeBchannelInfo
      emitter.emit "changed"
      cb()
, 1

changedFiles = ko.observableArray().extend {rateLimit: 1000}
changedFiles.subscribe (files) ->
  return unless running
  files = _.uniq files
  debug files
  if files.length
    changedFiles.removeAll()
  for oneFile in files
    readIfBchannel oneFile

readIfBchannel = (filename) ->
  if (filename.lastIndexOf("BChannelState", 0) is 0) #and (changedFiles.indexOf(filename) is -1)
    # debug "#{filename}, #{event}"
    readChangedFiles.push filename

#start watching /tmp and scan changed files for changes
watcher = fs.watch watchDir, (event, filename) ->
  if running
    changedFiles.push filename
    # readIfBchannel filename

readAllBchannels = ->
  fs.readdir watchDir, (err, files) ->
    readIfBchannel oneFile for oneFile in files
    unless files.length
      emitter.emit "changed"


activeCallsInterval = undefined

emitter.on "changed", _.throttle ->
  debug "channel status changed"
  localBchannels = []
  _.each bchannelsList, (bchan) ->
    bchanconfig = _.find bchannelConfigs, (conf) ->
      conf.bchannel is bchan

    if bchanconfig
      bchanconfig.runTime = helpers.calculateRuntime(bchanconfig.date)
    else
      bchanconfig =
        bchannel: bchan

    # bchanconfig.runTime = calculateRuntime(bchan.date) if bchan. bchan.date

    localBchannels.push bchanconfig


  # get active calls
  debug "filtering active calls"
  activeCalls = _.filter bchannelConfigs, (conf) ->
    conf.active

  debug "active calls: ", activeCalls.length
    # reset interval to send active calls runTime
  clearInterval activeCallsInterval if activeCallsInterval
  # if there are active calls, start a new interval for their runTime
  if _.size(activeCalls)
    activeCallsInterval = setInterval ->
      unless running
        clearInterval activeCallsInterval if activeCallsInterval
      debug "sending active calls"
      _.each activeCalls, (conf) ->
        conf.runTime = helpers.calculateRuntime(conf.date)
      emitter.emit "new", localBchannels
    , 2000

  # debug JSON.stringify(localBchannels, null, 4)
  emitter.emit "new", localBchannels

  # reset bchannel configs
, 2000, {leading: true}

bchannelsLib = emitter

bchannelsLib.start = ->
  if running
    debug "already running"
    return
  readAllBchannels()
  running = true
  debug "starting bchannels"
bchannelsLib.stop = ->
  unless running
    debug "already stopped"
    return
  running = false
  debug "stopping bchannels"

module.exports = bchannelsLib
